import requests
import rumps
import webbrowser
import time, threading

class Uncluttered(rumps.App):
    def __init__(self):
        super(Uncluttered, self).__init__("Syncing...")

        key = self.get_key()
        if key:
            self.title = "Syncing..."
        else:
            self.title = "Please set a key."
        self.menu = ["Sync", "Set Key", "About"]

        if self.title != "Please set a key.":
            self.title = self.run_sync(key)

        threading.Timer(60, self.sync, [""]).start()

    @rumps.clicked("About")
    def about(self, _):
        webbrowser.open("http://www.re-cycledair.com", new=2)

    def get_key(self):
        try:
            with open("key.txt") as f:
                key = f.read()
                return key
        except:
            return False

    def run_sync(self, key):
        r = requests.get("http://uncluttered.re-cycledair.com/api/%s/" % key)
        if r.status_code != 200:
            return "Invalid key."
        else:
            return r.content

    @rumps.clicked("Set Key")
    def set_key(self, _):
        key = self.get_key()
        window = rumps.Window('Paste your key in below', 'Key')
        window.title = 'Uncluttered Key'
        window.message = 'Paste your Uncluttered key in below.'

        if key:
            window.default_text = key
        else:
            window.default_text = "--- Enter Key ---"

        response = window.run()

        f = open('key.txt','w')
        f.write(response.text)
        f.close()

        self.title = self.run_sync(response.text)

    @rumps.clicked("Sync")
    def sync(self, _):
        key = self.get_key()
        if key:
            self.title = self.run_sync(key)
            threading.Timer(60, self.sync, [""]).start()
        else:
            self.title = "Please set a key."

if __name__ == "__main__":
    Uncluttered().run()


